#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, Giugno 2023

 Esercizio:
 Sintassi dei comandi e semplici operazioni aritmetiche.
 Questo esercizio richiede Python3, non va con Python 2

 Uso:
 python3
 >>>import Es02_sintassi as Es2

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es2_sintassi)

 >>>dir('Es02_sintassi')           # mostra il dizionario del modulo
 >>>help('Es02_sintassi')          # mostra un help (con la docstring)
 >>>Es02_sintassi.__doc__          # mostra la docstring
 >>>print(Es02_sintassi.__doc__)   # stampa per bene la docstring
  
 >>>from Es02_sintassi import *    # importo tutto nel namespace locale

 >>>import Es02_sintassi as Es2    # se uso questo il nome: Es02_sintassi
                                   # non esiste, al suo posto esiste Es2                                   

 >>>Es2.A                          # mostra una variabile del modulo
                                   
"""

import sys

if sys.version_info[0] < 3 :
   sys.exit("Questo esercizio richiede Python3, non va con Python 2") 
     

# commenti iniziano con '#', questo e' un commento 
# linee bianche vengono ignorate

# un commento puo' stare su piu' righe

H="""Effettuiamo questo esercizio in modo interattivo:
aprite una finestra terminale, e provate a fare
semplici operazioni"""

print(H)  # stampo una stringa multilinea 

#print("Stampo la docstring")
#print(80*"-")
#print(__doc__)
#print(80*"-")

print("\n\n-------- Definizione nomi (variabili) --------")

 

a=1         # 'a' e' un riferimento che punta al numero '1' 
A=2         # CASE SENSITIVE: 'a' ed 'A' sono oggetti diversi 

b=3 ; c=4   # il ';' separa le istruzioni 

print("A=",A,"; a=",a," ; b=",b," ; c=",4) 

A       # se scrivo una variabile sul terminale mi  mostra il valore
        # (ma se la scrivo in un modulo non vedo nulla) 
        
f=2.3 ; g='1' ; print(" f=2.3 ; g='1' , definisco float e caratteri\n")
        
a,b=b,a

print("--> Assegnazioni multiple: i=j=11.2 ")

i=j=11.2

x,y,z=1,2,3 ; print(" x,y,z=1,2,3 ")

x,*y=1,2,3,4 ; print("x,y=1,2,3,4 : x: ",x," ed in y la lista: ",y)


print("posso fare: a,b=b,a per scambiare 2 valori. Ora ho: a,b=>",a,",",b,"\n")


d=a  ; a=77 ; print("--> i nomi sono riferimenti a costanti:  d=a  ; a=77 ; d non cambia =>",d) 

aa=[1,2,3] ; bb=aa ; aa[2]=77 ; print(" aa=[1,2,3] ; bb=aa ; aa[2]=77 ; Qui bb cambia:",bb)

print("--> ridefinizione, eliminazione nomi (e garbage collection) ")

k=12 ; print(" k=12 ; =>",k)
k=33 ; print(" k=33 ; =>",k)
del k ; print("del k; print(k) # elimino k, poi cerco di stamparlo") 

# qui gestisco l'errore (eccezione)
import sys
import traceback
try:
  print(" =>",k)
except:
  eccname=sys.exc_info()[0]
  print("ERRORE!! viene sollevata l'eccezione: ",eccname," che stampa:\n")
  traceback.print_exc()
  
    

print("\n\n-------- Operazioni algebriche (python come calcolatrice) --------")

a=7; a+3 ; print("a=7;a+3 => ",a+3,"\n") 

b=a/3  ; print("La divisione produce SEMPRE float; in Python 2 non era cosi':")
c=4/2  ; print(" b=a/3 =>",b," ; c=4/2 =>",c,"\n" )

d=4//2 ; print("per la divisione intera (che tronca): ")
e=4.5//1.6 ; print(" d=4//2 => ",d," ; e=4.5//1.6 => ",e," => produce un float, ma troncato\n") 

z=3%4  ; print("resto divisione: z=3%4 =>",z,"\n")

s=2**100 ; print("elevazione a potenza (int ha numero arbitrario di cifre): \n s=2**100 => ",s,"\n")
x=2.0*3  ; print("x=2.0*3 => ",x)
y=2**3.1 ; print("y=2**3.1 => ",y, "anche esponenti float")
z=2**0.5 ; print("z=2**0.5 => ",z,"\n")

a=4<<1 ; b=4>>1 ; print("<< >> shift sui bit: \n a=4<<1 => ",a, " ; b=4>>1 => ",b,"\n") 
c=2|1  ; d=2&1 ; e=3^1 ; print("& | ^ and, or nor sui bit: (10 or 01) => 11 \n c=2|1  => ",c,
                               " ; d=2&1 => ",d," ; e=3^1 => ",e,"\n")
a=~0 ; b=~1 ; c=~-1  ; print("~ inverte i bit (rappr. complemento a 2) : \n a=~0 => ",a,
                             " ; b=~1 =>",b," ; c=~-1 => ",c,"\n") 

a=1 ; a+=1 ; print("operazione e riassegnazione: a=1 ; a+=1 => ",a,"\n")


a=1 ; b=3.0 ; c=a+b ; print("\nConversioni automatiche: a=1 ; b=3.0 ; c=a+b => ",c)

try:
  a=1 ; b='2'  ; print("ma solo fra tipi compatibili:  => a=1 ; b='2' ; c=a+b provoca un errore =>\n ")
  c=a+b
except:
  traceback.print_exc()
  print() # stampa linea bianca 

ta=type(a) ; tb=type(b) ; print("per sapere il tipo :type(a) => ",ta," ; type(b) => ",tb) 

print("Numeri complessi: type(3.5+5j) => ",type(3.5+5j))



print("\n\n-------- Operazioni logiche --------")

a=1 ; b=2 ; x=a>b ; y=a<b ; z=(a==b) ; u=(a!=b)
print("a=1, b=2 ;\n a>b => ",x,"\n a<b => ",y,"\n a==b => ",z,"\n a!=b => ",u ,"\n")

x=True ; y=False ; x or y ; x and y ;
print("x=True ; y=False ; x or y => ",x or y," ; x and y => ",x and y,"\n")
a=1 ; b=2 ; x=0 ; a+b and x ; x or a+b ;  
print("or, and ritornano l'ultima espressione valutata: \n",
      "a=1 ; b=2 ; x=0 \n a+b and x => ",a+b and x,
      "\n x or a+b => ",x or a+b ,"\n")

print("\n\n-------- Espressioni condizionali in Python 3 (operatore ternario) --------")

b=0; a=32.5/2 if b==0 else 'Z' 
print(" b=0; \n a=32.5/2 if b==0 else 'Z' \n a=> ",a,"\n") 


print("\n\n-------- funzioni per i numeri ----") 

a=abs(-3) ; b,c=divmod(3,2) ; d=int('1') ; e=float('3.2') ; f=round(3.333333,2) ; es=str(e)
print(" abs(-3) => ",a)
print(" b,c=divmod(3,2) => ",b,",",c)
print(" d=int('1') => ",d)
print(" e=float('3.2') => ",e)
print(" es=str(e) => ",es)
print(" f=round(3.333333,2) => ",f)
print(" rappresentazioni bin, oct, hex: hex(15) =>",hex(15))

print("\n\n----- modulo math ------")
import math
math.e ; math.pi ; math.cos(90.0) 
print("import math")
print("math.pi  => ",math.pi)
print("math.e  => ",math.e)
print("math.cos(math.pi/2)  => ",math.cos(math.pi/2))
print("math.factorial(3)  => ",math.factorial(3))
print("math.log10(100)  => ",math.log10(100))
print("math.exp(0)  => ",math.exp(0))


print("\n\n----- Esercizio  concluso correttamente ------ ",)

