#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, giugno 2023
 revised maggio 2023

 Esercizio:
    numpy
 
 Questo esercizio richiede Python3, non va con Python 2

 Uso come modulo:
 python3
 >>>import Es12_numpy as Es12

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es12)

                                   
"""

print(" Esercizio su numpy")
print("Devo importare il pacchetto numpy")
print("import numpy as np") 

import numpy as np # importo il pacchetto numpy

# questi mi servono per gestire gli errori 
import sys
import traceback


# --------- creare array --------- 

ar=np.array([1,2,3,4,5,6])  # da una lista 

print("creo array da una lista: ")
print(ar)
print("ar.size: ",ar.size," : ha 6 elementi")
print("ar.ndim: ",ar.ndim," : e' ad una dimensione" )
print("ar.shape: ",ar.shape, " : tupla : una riga, di ",ar.size,"  valori (ha una dimensione, e' un vettore)")
print("ar.dtype: ",ar.dtype, " : sono interi ")
print("ar.itemsize: ",ar.itemsize, ": dimensioni di un elemento (in bytes)" )

print("creo array a 2 dimensioni da una lista di liste: ")
ar2=np.array([[11,12.0],[21,22]])  # notate: un numero e' float 
print(ar2)
print("ar2.size: ",ar2.size," : ha 4 elementi")
print("ar2.ndim: ",ar2.ndim," : e' a 2 dimensione" )
print("ar2.shape: ",ar2.shape, " : tupla : 2 righe, 2 colonne, e' una matrice")
print("ar2.dtype: ",ar2.dtype, " : sono float (ha convertito gli interi)")
print("ar2.itemsize: ",ar2.itemsize, ": dimensioni di un elemento (in bytes)" )

print("crea array vuoto, 3 righe e 4 colone con: \n e=np.empty((3,4))")
e=np.empty((3,4))
print(e)
print(" .. non e' vuoto, ha contenuto a caso")

print(" array con zeri dentro:\n np.zeros((3,4))")
z=np.zeros((3,4))
print(z)

#Notate la stringa: delimitata da apici sempici, dato che contiene doppi apici
print(' array con uno, e gli dico che sono float:\n np.ones((3,4),dtype="float")')
u=np.ones((3,4),dtype="float")
print(u)

print("array con numeri pari: \n np.arange(2,8,2)")
p=np.arange(2,8,2)
print(p)

print(" 10 valori equispaziati, da 0 a 2: np.linespace(0,2,10)")
eq=np.linspace(0,2,10)
print(eq)


print(' array di stringhe: \n c=np.array([1,"b2","c3"])')
c=np.array(["1","b2","c3"])

print(c)
print(" ha tipo: c.dtype: ",c.dtype," : e' un unicode")
print(" aveva un numero, ha convertito tutto a caratteri, l'array deve essere omogeneo")

# ------ reshape: cambio forma ad array -----

print(" reshape: cambio una matrice in un vettore")
print(ar2)
res=ar2.reshape(4) 
print("ar2.reshape(4) , ed ottengo: ")
print(res)

print(" viceversa: cambio un vettore in una matrice")
print(ar)
res2=ar.reshape((3,2))
print("ar.reshape((3,2)) , ed ottengo: ")
print(res2)

# --------------- unire, separare,trasformare  array ---
print("\n")

print("Unisco 2 vettori: \n np.concatenate((p,ar))")
conc=np.concatenate((p,ar))
print(conc)

print("Elimino valori multipli: \n np.unique(conc)")
conc2=np.unique(conc)
print(conc2)

print(" di due vattori faccio una matrice: \n np.vstack(conc2,conc2)")
stacked=np.vstack((conc2,conc2)) # vuole una tupla in argomento
print(stacked)


print(" vstack ed hstack possono unire matrici in orizzontale o verticale")

print(ar2)
print(" np.vstack((ar2,ar2)) ; ottengo: ")
ar2v=np.vstack((ar2,ar2))
print(ar2v)

print(" np.hstack((ar2,ar2)) ; ottengo: ")
ar2h=np.hstack((ar2,ar2))
print(ar2h)

print(" vsplit ed hsplit mutano una matrice in una lista di array")
print(ar2)
ar2vs=np.vsplit(ar2,2)
print(" np.vsplit(ar2,2) produce una lista di array con le righe: ")
print(ar2vs) 

ar2hs=np.hsplit(ar2,2)
print(" np.hsplit(ar2,2) produce una lista di array con le colonne:")
print(ar2hs) 

print(" La trasposa dell'array ar2: ar2.T: ")
print(ar2.T)

print(" la matrice trasformata in un vettore: ar2.flatten()")
print(ar2.flatten())

# -------- selezionare elementi ----
print("\n selezione elementi di vettori o matrici")
print(" la notazione e' simile a quella delle liste ")
print(ar2)
print("ar2[0][1] : prima riga: seconda colonna: ",ar2[0][1])

print(" e' piu' efficiente la notazione: ar2[0,1]: ",ar2[0,1])

print("e' facile estrarre righe di matrici, come array monodimensionali: ar2[1] :",ar2[1])

print(" Selezione elementi con array logici")
z=np.array([1,2,3,4,5])
j=np.array([True,False,True,False,True])
print(z)
print("array booleano: ",j)
print("z[j] :",z[j])

print("z<3 e' un array booleano: ",z<3) 
print(" si puo' usare come indice per selezioni: z[z<3]:",z[z<3])

print(" si puo' anche usare una lista di indici: z[[2,4]]: ",z[[2,4]])

# ------ algebra con array --------

print("\n esempi di algebra con arrays")

print(" sottraggo un numero ad ogni elemento ar-1000 => ",ar-1000)

print(" somma di vettori: ",ar," + ",ar," => ",ar+ar)

print(" moltiplicazione membro a membro ar*ar =>",ar*ar)

print(" moltiplicare ogni riga di una metrice per un vettore ar2*[100,1000] => ",ar2*[100,1000])

print(ar2)
print(" somma degli elementi ar2.sum() ",ar2.sum())
print(" minimo ar2.min() ",ar2.min())
print(" amassimo ar2.max() ",ar2.
max())
print(" media: ar2.mean() ",ar2.mean())
print(" minimo di ogni colonna  ar2.min(axis=0) ",ar2.min(axis=0))
print(" minimo di ogni riga ar2.min(axis=1) ",ar2.min(axis=1))

print(" numpy ha molte funzioni gia' trasformate per essere adatte ad array")
print(" per esempio np.sqrt([1,4,9]) produce: ",np.sqrt([1,4,9]))


print("\n applicazione di funzione arbitraria a vettore")

print("definisco una funzione")
def funct(a):
   #import numpy as np  # e' gia' importato
   b=np.cos(a)
   return b

print("la rendo adatta a trattare vettori o matrici")    
vfunct=np.vectorize(funct)

d=np.array([0,np.pi])

print("definisco un vettore d : ",d)

print("applico la funzione modificata (fa il coseno)")
vd=vfunct(d)

print("ottengo: cos(d): ",vd)

print("...si poteve fare semplicemente: np.cos(d) :",np.cos(d))
print(" numpy ha dentro le principali funzioni matematiche")



print(" --------- esercizio concluso -----")






