#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, giugno-2023

 Esercizio:
   Uso di matplotlib per la grafica
 
   Questo esercizio richiede Python3

 Uso come modulo:
   python3
   >>>import Es12_matplotlib as Es12

   >>># eventualmente
   >>>import imp
   >>>imp.reload(Es12)
 
   (se uso from  Es13_matplotli import * # non devo mettere prefisso 'Es13.'
 
 Uso come programma, in Unix:
 
 Es13_matplotlib.py
                                   
"""
#!/usr/bin/python 
#Esempio plot x,y


import matplotlib.pyplot as plt # importo pyplot
import numpy as np              # in questo esempio usiamo numpy

print("Un semplice grafico, con alcuni punti rossi")

plt.plot([1,2,3,4], [1,4,9,16], 'ro') # r:red, o: circle
 
plt.axis([0, 6, 0, 20]) # estremi degli assi:
                        # minimo e massimo di asse x e di asse y                                  

plt.show() # questa funzione di pyplot mostra il grafico 


print("Un semplice grafico, con una retta spessa ")

x=np.array([1,2,3,4,5])           # vettore di numpy
y=np.array([10,20,40,45,50])      # altro vettore di numpy

plt.plot(x,y,linewidth=10,linestyle='-.')  #  definisco il tipo di linee
 
plt.axis([0, 5, 0, 50])           # estremi degli assi:
                                  # minimo e massimo di asse x e di asse y                                  

plt.show()         # questa funzione di pyplot mostra il grafico 

print("Un semplice grafico, con sin e cos  ")

X = np.linspace(-np.pi, np.pi, 256, endpoint=True) # il valore np.pi e' compreso
C = np.cos(X)                    
S = np.sin(X)    # numpy ha tutte le funzioni trigonometriche                     

plt.plot(X, C)   # faccio 2 curve sullo stesso plot
plt.plot(X, S)

plt.show()

print("Un semplice grafico, con scritte e titolo ")

x=[1,2,3,4]
y=[2,4,6,8]
z=[1,4,9,16]

plt.plot(x, y, 'ro',x,z,'bs') # faccio 2 curve sullo stesso plot
plt.axis([0, 6, 0, 20])
plt.title('Semplice plot')
plt.xlabel('asse x')         # scritte sugli assi
plt.ylabel('asse y')
plt.text(4,18,'una parabola')  # un testo, in x=4, y=18
plt.text(4,9,'una retta')

plt.show()

print("Un semplice istogramma ")

x = [1,2,2,2,2,3,3,3,4,4,4,4,4,4,5,5,5,5,5]

n, bins, patches = plt.hist(x,5) # torna tupla con valori e intervalli 

# Sintassi di matplotlib.pyplot.hist :
#    x: sequenza o array di numpy 
#    n: valori per i diversi intervalli
# bins: coordinate degli intervalli (valor medio)
# patches: oggetti con le coordinate dei disegnini dei rettangoli

#print(n)
#print(bins)
#print(patches)

plt.xlabel('valore')
plt.ylabel('frequenza')
plt.title('Istogramma')

plt.axis([0, 5, 0, 10])
plt.grid(True)
plt.show()

print("Un grafico a torta (a pie plot)")


x = [10,50,20,20]

plt.pie(x,colors=('b','g','y','r'),
           labels=('blu','verde','giallo','rosso'))
plt.title('Torta')

plt.show()
