#!/usr/bin/python3
"""
 Corso di Pyton per AIAM, Marcello Galli, giugno 2023
 revised maggio 2023

 Esercizio:
    pandas
 
 Questo esercizio richiede Python3, non va con Python 2

 Uso come modulo:
 python3
 >>>import Es14_pandas as Es14

 >>># eventualmente
 >>>import imp
 >>>imp.reload(Es14)
 
"""

print(" Esercizio su pandas")
print("Devo importare il pacchetto pandas")
print("import import pandas as pd") 

 # importo il pacchetto pamdas
 
import pandas as pd
import numpy as np   # mi serve anche questo
 

print("--------- Series -----------")

print("mi creo una series vuota di interi: k= pd.Series(dtype='int')")

k= pd.Series(dtype='int') 
print(k)

print("una serie puo ' avere un nome: k= pd.Series(dtype='int',name='vuota')")
k= pd.Series(dtype='int',name='vuota') # una Series puo' avere un nome
print(k)

print("una serie di interi, con lettere come indici ")
print("s= pd.Series([0,1,2,3,4],index=['a', 'b', 'c', 'd', 'e'])")

s= pd.Series([0,1,2,3,4],index=['a', 'b', 'c', 'd', 'e'])
print(s)

# numeri a caso, fra 0 ed 1, con interi come indice

s1 = pd.Series(np.random.rand(5), index=[1,2,3,4,5])

# utilizzando un dizionatio le *key* diventano gli indici

s2 = pd.Series( {'a' : 0., 'b' : 1., 'c' : 2.} ) 

# utilizzzando un singolo valore 

s3=pd.Series(5., index=['a', 'b', 'c', 'd', 'e'])

# se e' datto da un dizionario e c'e' 
# un indice cui non corrisponde una
# chiave nel dizionario il valore messo e' *NaN*

d = {'a' : 0., 'b' : 1., 'c' : 2.}
pd.Series(d, index=['b', 'c', 'd', 'a'])

print("serie con valore mancante: ",d)

#Siccome le Series sono array di numpy hanno tutte le
#proprieta' degli array  du numpy.

s[s > s.median()]  # Series dei valori maggiori della mediana
     
s[s == s.mean()]   # Series con il valor medio
 
s[[1,2]]           # Uso di liste come indici (si ottengono Series) 
s[['b','c']]    
   
np.sum(s)         # ma somma dei valori 

s+s               # Series con elementi di valore doppio
s*2 


# Lo slicing si fa come per gli array di numpy:
# Elementi e parti di una Series (*slices*), possono essere
# ottenuti utlizzando indici interi, fra quadre, oppure
# il valore dell'indice::

s= pd.Series([0,10,20,30,40],index=['a', 'b', 'c', 'd', 'e'])   
   
s[1]  # vale 10 
      
s[:3] # una Series con i primi 3 elementi (i numeri da 0 a 2) 

s['b'] # vale 10 
   
s['b':'e'] # una serie con fli elementi con indici da 'b' ad 'e' (compresi)

# L'operatore *in* opera sull'index::

'c' in s  # e' True
10 in s   # e' False 
   
    
# for itera sull'array, non sull'indice, 
# oppure si puo' iterare sull'indice::

for  i in s.index: 
   print(i,s[i])    #stampa la lista: indice, valore 

# Usando indici con elementi si ha un errore se l'elemento non 
# e' presente, la funzione get invece produce l'oggetto 'None'

#s[f]       # da errore keyerror
#s.get('f') # da "None"

#Serie possono esere convertire in dizionari:: 

s.to_dict()
 
# E' possibile cambiare l'indice riassegnando l'oggetto Index::

s.index=['a','b','c','d','e'] 
  
print(" ------------- DataFrames ----- ")

# un dataframe vuoto
dfv=pd.DataFrame() 

print("Un dataframe vuoto? ",dfv.empty)

df=pd.DataFrame({'A':[11,21,31],'B':[12,22,32],'C':[13,23,33]},index=['a','b','c'])
print( 'Un dataframe:\n',df )

print(" l'attributo df.index: \n",df.index)
print(" l'attributo df.columns: \n",df.columns)

#Per fare array numpy: 
print(' df.values lo trasforma in array numpy:\n ',df.values)
df.values                 # come sopra 

print("vediamo gli altri attributi (simili a quelli di numpy") 
print( 'df.axes \n',df.axes)      # indici (index e columns)
print( 'df.ndim \n',df.ndim)
print( 'df.shape \n',df.shape)    # dimensioni (2 per un dataframe)  
print( 'df.dtypes \n',df.dtypes)  # tipo delle colonne cols 


#Per fare array numpy: 
print(' df.values lo trasforma in array numpy:\n ',df.values)
df.values                 # come sopra 

# converto a float32
df1=df.astype('float32')        # converto da interi a float a 32 bits
print( "faccio: df1=df.astype('float32'): df1.dtypes \n",df1.dtypes)  

# ------------ slicing ------------------

print(" le colonne sono Series: df['B']:\n" , df['B'])
print( "prima colonna come serie: df['A'] \n",df['A'])

print("un datraframe con le prime 2 colonne: df[['A','B']] =>\n",df[['A','B']])
print( "primo elemento della seconda colonna:\n df['B']['a']=> ",df['B']['a'])

print("uso di 'loc' ed 'iloc' per selezionare righe e colonne (primo indice:riga): ")

print(" df.loc['a':'c','B':'C'] => \n",df.loc['a':'c','B':'C'])

print(" iloc e' simile a loc, ma usa interi: df.iloc[-1] => \n",df.iloc[-1])
print(" df.iloc[0:2,1:2] => \n",df.iloc[0:2,1:2])


print( "primo elemento della prima col: df.loc['a','B']=> " ,df.loc['a','B'])
print( "primo elemento della prima col: df.iloc[0][1]=> ",df.iloc[0][1])

print( "seconda riga come dataframe: df.iloc[1:2] ")
print( df.iloc[1:2])

print( "uso di booleani come indici: df.iloc[[False,True,False]] ")
print( df.iloc[[False,True,False]])


print( "cerco primi 2 elementi diagonali :df.lookup(['a','b'],['A','B'])")
print( df.lookup(['a','b'],['A','B']))

print(" per selezionare un singolo elemento si usa at")
print("uso di 'at' ; df.at['b','C']=>\n",df.at['b','C'])
print("uso di 'iat' ; df.iat[1,2]=>\n",df.iat[1,2])

# 

print("uso di array logici per selezione")

df['A']['c']=131
print(" dataframe modificato: df['A']['c']=131 ",df)
print("df[df['A']>df['B']] \n",df[df['A']>df['B']]) 


# copia (df2=df NON copia, assegna nuovo nome)

df2=df.copy()

# itero su colonne

print( "for: itera su nomi colonne  ")
for i in df:
    print( i)

print( "iterrows itera su righe (si ottengono Series, con un nome  ")

for index,val in df.iterrows():
    print('nome series:',index,"\n",val)

print("ci sono molte funzione per serie e dataframe, come in numpy")
print("media: \n",df.mean())
   
print("somma dei valori delle righe:  df.sum(axis=0)\n",df.sum(axis=0))
print("somma dei valori delle colonne: df.sum(axis=1)\n",df.sum(axis=1))

 # Series, con somma valori col 
      
df.sum(0)
   
df.sum(axis=1) # Series, con somma sulle righe 

print(" --- fine esercizio ---") 
   

