#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on june 2922

@author: marc

Esercizio-B, ma modificato per usare  pandas
si vede come sia tuttu piu' semplice
utilizzando pandas
'
"""

filename="Meteo2122.csv"    # nome del file coi dati

# pandas integra numpy e matplotlib, che non occorre
# piu' importare se non usati in modo esplicito
import pandas as pd 

import numpy as np 
#import matplotlib.pyplot as plt 
#import csv   # importo il modulo per i csv


# questa funzione non serve piu 
def toiso8601(data):
    d,m,y=data.split("/")
    dataiso="-".join([y,m,d])
    return dataiso

# pandas apre il file, prende il nome delle
# colonne dalla linea indivate in 'header' 
# ammette diversi dialetti del formato csv

df=pd.read_csv(filename,sep=';',
                skipinitialspace=True,
                skip_blank_lines=True,
                comment='#',
                header=1,decimal='.')

df.info()  # guardo come e' fatto il dataframe che ottengo

# cambio nomi alle colonne
df.columns=['data','tmin','tmed','tmax','umid','pioggia','tsuolo']
df.info()

# inserisco la data nel formato interno di python: datetime64
# trasformando la stringa nella colonna: "data"
df["dataok"]=pd.to_datetime(df["data"],format="%d/%m/%Y")
df.info()

# esempio di test sui dati
errore=df['tmin']>df['tmax']

if errore.any():
      print('errore nei dati')
else:
      print('dati OK')   
      
# apertura file, gestione righe con nomi colonne,
# creazione array di numpy e tutto il resto non serve,
# le colonne del csv ora le colonne del dataframe

"""    
f=open(filename,'r')
# creo un oggetto reader, per leggere il file
r=csv.reader(f,delimiter=";")
# next fornisce la riga successiva, come lista di stringhe
l1=next(r)  # prime riga
l2=next(r)  # seconda riga

'''
# ho saltato le prime 2 linee, leggo le altre
# mi faccio una list per ogni riga

data=[]
tmin=[]
tmax=[]
tmed=[]
umid=[]
pioggia=[]
tsuolo=[]

for linea in r:    # r e' un iteratore
#for i in range(5):
    #linea=next(r)
    #print(linea)
    d=toiso8601(linea[0])
    data.append(np.datetime64(d))
    tmin.append(float(linea[1]))    
    tmax.append(float(linea[2]))
    tmed.append(float(linea[3]))
    umid.append(float(linea[4]))
    pioggia.append(float(linea[5]))
    tsuolo.append(float(linea[6]))
    
f.close()      # il file non serve piu, lo chiudo
 
# trasformo in ndarray di numpy, con la funzione array

arrdata=np.array(data)
arrtmin=np.array(tmin,dtype=float)
arrtmax=np.array(tmax)
arrtmed=np.array(tmed)
arrumid=np.array(umid)
arrpioggia=np.array(pioggia)
arrtsuolo=np.array(tsuolo)

# faccio dei controlli sui dati

prova1=arrtmin<arrtmax  # crea lista di booleani
if False in prova1 : print("errore nei dati, deve essere tmin<tmax")

# guardo alcuni valori

"""

# le funzioni max() min etc valgono anche per le Series di pandas
print('max: ',df['tmax'].max())



"""
print("il massimo dei massimi : ",arrtmax.max())
print("il minimo dei minimi : ",arrtmin.min())

# grafica temperature minime
"""

# la grafica ha interfaccia semplificata,
# le funziodi di grafica diventano attribudi dei dataframe
# (ma internamente si usa sempre matplotlib)

df.plot(x='dataok',y='tmin',title="temperature minime")



"""
plt.plot(arrdata,arrtmin)

giorno1=arrdata[0]                 # limiti plot per i giorni
giorno2=arrdata[arrdata.size-1]

plt.axis([giorno1,giorno2,-10,30])  # limiti per gli assi
plt.xlabel("gradi")
plt.ylabel("date")                 # nomi degli assi
plt.title("Temperature minime")    # titolo del grafico

plt.savefig("figtmin.png")  # per salvare il grafico
plt.show()

# grafica minime e massime 


line2d=plt.plot(arrdata,arrtmin,'r.',arrdata,arrtmax,'b*')# torna un oggetto Line2D

plt.axis([giorno1,giorno2,-10,30])  # limiti per gli assi
plt.xlabel("gradi")
plt.ylabel("date")                 # nomi degli assi
plt.title("Temperature minime e massime")    # titolo del grafico

plt.setp(line2d,markersize=0.8) # do dimensione ai punti disegnati

plt.show()
#plt.clf() # pulisce tutto, non serve. lo fa show()
         
#  umidita e temperatura al suolo 

pathcoll=plt.scatter(arrtsuolo,arrumid)

plt.axis([arrtsuolo.min(),arrtsuolo.max(),arrumid.min(),arrumid.max()])  
plt.xlabel("temperatura suolo")
plt.ylabel("umidita")                 # nomi degli assi
plt.title("Temperatura ed umidita")
plt.setp(pathcoll,sizes=[2])

plt.show()

# c'e' una correlazione ?
"""

# posso usare funzioni di numpy con le series
coeff=np.polyfit(df['tsuolo'],df['umid'],1)

#coeff=np.polyfit(arrtsuolo,arrumid,1)

print(" Fit lineare temperatura al suolo-umidita",coeff)

df['fitval']=df['tsuolo']*coeff[0]+coeff[1]


#devo specificare che faccio i 2 plot sovrapposti sulla stessa figura,
# do l'axis ax alla chiamata per il secondo plot 
ax=df.plot.scatter(x='tsuolo',y='umid',title='scatter plot tsuolo, umid')
df.plot(x='tsuolo',y='fitval',ax=ax)


"""
fitval=arrtsuolo*coeff[0]+coeff[1]  # valori del fit ai punti di temperatura

pathcoll=plt.scatter(arrtsuolo,arrumid)

plt.axis([arrtsuolo.min(),arrtsuolo.max(),arrumid.min(),arrumid.max()])  
plt.xlabel("temperatura suolo")
plt.ylabel("umidita")                 # nomi degli assi
plt.title("Temperatura ed umidita")
plt.setp(pathcoll,sizes=[2])

plt.plot(arrtsuolo,fitval,"r-")  # plotto anche il fit

plt.show()

"""











